/*
** Copyright (C) 2000 Idan Shoham <idan@m-tech.ab.ca>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "project.h"
#include "projectFile.h"


#if 0
#define DEBUG	1
#endif

int main(int argc, char **argv)
{
    ProjectFile projectFile;

    try 
    {
	if ( argc == 1 )
	{
	    projectFile.Load("workplan.sched");
	}
	else
	{
	    for ( int i = 1; i < argc; ++i )
	    {
		if ( argv[i][0] == '-' )
		{
		    printf("USAGE: %s file1 [file2 file3 ...]\n", argv[0]);
		    exit(0);
		}
		else
		{
		    projectFile.Load(argv[i]);
		}
	    }
	}
    }
    catch ( ProjectFileException & e )
    {
	cerr << "Project not loaded: " << e.what() << endl;
	exit(1);
    }

    
    try 
    {
	projectFile.checkComplete();

#ifdef DEBUG
    projectFile.Print();
#endif

    Project project = projectFile.project();
    project.DoScheduling();

    Reporter reporter = projectFile.reporter();
    reporter.DoReports( &project );
    
    }
    catch ( ProjectException & e )
    {
	cerr << "ProjectException: " << e.what() << endl;
	exit(1);
    }
    catch ( ProjectFileException & e )
    {
	cerr << "ProjectFileException: " << e.what() << endl;
	exit(1);
    }

    return 0;
}
