// -*- C++ -*- 
#ifndef PROJECTIO_H
#define PROJECTIO_H

#include "project.h"
#include "reporter.h"

class ProjectFile 
{
public :
    ProjectFile();
    Project & project() { return mProject; };
    Reporter & reporter() { return mReporter; };
    void Load(char *name);
    void checkComplete();

private :
    Project mProject;
    Reporter mReporter;

    void Error(char *fmt, ...);
    void Warning(char *fmt, ...);

    int ParseLine(char *linebuf, char ***pwords);
    void Vacation(char *resid, char *d1name, char *d2name);
    void AddCandidates(char *taskid, char **resources, int Nresources);
    void WorkBlock(const char *taskid, const char *resid, 
		   char *day1, char *day2, TimeBlock::Type type);
    void AddTaskGraph( char *d1name, char *d2name, char *fname );
};


class ProjectFileException 
{
public:
    ProjectFileException( string reason );
    ~ProjectFileException();
    string what() const;

private:
    string mReason;
};

#endif
